var Fraction, differenceFractions, egypt, pgcd, produitFractions, quotientFractions, sommeFractions;


pgcd = function(x, y) {
  var _ref;
  while (y !== 0) {
    _ref = [y, x % y], x = _ref[0], y = _ref[1];
  }
  return x;
};

Fraction = (function() {
  function Fraction(n, d) {
    var facteur, _ref;
    this.n = n != null ? n : 1;
    this.d = d != null ? d : 1;
    facteur = pgcd(this.n, this.d);
    this.n /= facteur;
    this.d /= facteur;
    if (this.d < 0) {
      _ref = [-this.n, -this.d], this.n = _ref[0], this.d = _ref[1];
    }
  }

  return Fraction;

})();

Fraction.prototype.toString = function() {
  if (this.d === 1) {
    return "" + this.n;
  } else {
    if (this.n / this.d < 0) {
      return "(-" + (-this.n) + "/" + this.d + ")";
    } else {
      return "" + this.n + "/" + this.d;
    }
  }
};

Fraction.prototype.eq = function(autre) {
    return this.n * autre.d == this.d * autre.n;

};
Fraction.prototype.lt = function(autre) {
    return this.n * autre.d < this.d * autre.n;

};
Fraction.prototype.gt = function(autre) {
    return this.n * autre.d > this.d * autre.n;

};
Fraction.prototype.le = function(autre) {
    return this.n * autre.d <= this.d * autre.n;

};
Fraction.prototype.ge = function(autre) {
    return this.n * autre.d >= this.d * autre.n;

};

Fraction.prototype.plus = function(autre) {
    return new Fraction(this.n * autre.d + this.d * autre.n, this.d * autre.d);
};

Fraction.prototype.moins = function(autre) {
    return new Fraction(this.n * autre.d - this.d * autre.n, this.d * autre.d);
};

Fraction.prototype.fois = function(autre) {
    return new Fraction(this.n * autre.n, this.d * autre.d);
};

Fraction.prototype.sur = function(autre) {
    return new Fraction(this.n * autre.d, this.d * autre.n);
};

Fraction.prototype.inverse = function() {
  return new Fraction(this.d, this.n);
};

Fraction.prototype.opposé = function() {
  return new Fraction(-this.n, this.d);
};

Fraction.prototype.toFloat = function() {
  return this.n / this.d;
};

sommeFractions = function(f1, f2) {
  return new Fraction(f1.n * f2.d + f1.d * f2.n, f1.d * f2.d);
};

differenceFractions = function(f1, f2) {
  return new Fraction(f1.n * f2.d - f1.d * f2.n, f1.d * f2.d);
};

produitFractions = function(f1, f2) {
  return new Fraction(f1.n * f2.n, f1.d * f2.d);
};

quotientFractions = function(f1, f2) {
  return new Fraction(f1.n * f2.d, f1.d * f2.n);
};


egypt = function(uneFraction) {
  var e, f, réduites;
  f = uneFraction;
  e = Math.floor(f.toFloat());
  f = f.moins(new Fraction(e, 1));
  réduites = [e];
  while (f.n !== 1) {
    e = new Fraction(1, Math.ceil(f.inverse().toFloat()));
    réduites.push(e);
    f = f.moins(e);
  }
  réduites.push(f);
  return réduites;
};
